using System;
using System.Text.RegularExpressions;
using System.Xml;
using System.Windows.Forms;

namespace CreateWorksheetXML
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private const string spreadsheetML = @"http://schemas.openxmlformats.org/spreadsheetml/2006/main";

    private string pathDesktop = System.Environment.GetFolderPath(Environment.SpecialFolder.Desktop);


    private void btnCreateWS_Click(object sender, EventArgs e)
    {
      string filePath = pathDesktop + @"\Worksheet.xml";
      CreateWorksheetXmlFile(tbCellAddess.Text,tbCellValue.Text, filePath);
    }


    private void CreateWorksheetXmlFile(string cellAddress, string cellValue, string filePath)
    {
      //<worksheet xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main">
      //  <sheetData>
      //    <row r="1" spans="1:1">
      //      <c r="A1" t="inlineStr">
      //        <is>
      //          <t>Sample Text</t>
      //        </is>
      //      </c>
      //    </row>
      //  </sheetData>
      //</worksheet>

      XmlDocument xDocWS = new XmlDocument();
      XmlElement tagWorksheet = xDocWS.CreateElement("worksheet", spreadsheetML);
      xDocWS.AppendChild(tagWorksheet);

      // create the sheetData tag (must be present, but can be empty)
      XmlElement tagSheetData = xDocWS.CreateElement("sheetData", spreadsheetML);
      tagWorksheet.AppendChild(tagSheetData);

      // Create Row
      XmlElement tagRow = xDocWS.CreateElement("row", spreadsheetML);
      tagRow.SetAttribute("r", GetRowNumber(cellAddress));
      tagSheetData.AppendChild(tagRow);

      // Create Cell:
      XmlElement tagCell = xDocWS.CreateElement("c", spreadsheetML);
      tagCell.SetAttribute("r", cellAddress);

    #region "Inline String"
      tagCell.SetAttribute("t", "inlineStr");

      XmlElement tagIS = xDocWS.CreateElement("is", spreadsheetML);
      tagCell.AppendChild(tagIS);

      XmlElement tagText = xDocWS.CreateElement("t", spreadsheetML);
      tagText.InnerText = cellValue;
      tagIS.AppendChild(tagText);
    #endregion

    #region "Formula"
      ////  <c r="A1">
      ////    <f>A2+A3</f>
      ////  </c>
      // XmlElement tagFormula = xDocWS.CreateElement("f", spreadsheetML);
      // tagFormula.InnerText = cellString;
      // tagCell.AppendChild(tagFormula);
    #endregion

      tagRow.AppendChild(tagCell);

      xDocWS.Save(filePath);
    }


    private string GetRowNumber(string cellref)
    {
      Regex numbers = new Regex(@"\d+");
      Match m = numbers.Match(cellref);
      if (m.Success)
        return m.Value;
      else
        return "1";
    }
  
  }
}